<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}


//--------------------------------
// Load classes
//--------------------------------
require 'inc/class_thread.php';


//---------------------------------
// Check if i have submit the form
//---------------------------------
$this->classes->lang->load('newpost');


if(!isset($_POST['topicid']))
	{
	if(!isset($_GET['tid']) || $_GET['tid']=='')
		$this->classes->error->simple_error('no_tid');
	$tid=$_GET['tid'];
	
	if(isset($_GET['quote']))
	{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_quote_by_post_id', $_GET['quote']));
		$temp = $this->classes->db->fetch_array($query);
		if(isset($_GET['edit']))
		{
			$init_text=stripslashes($temp['text']);
			if($temp['user_id'] != $this->classes->user->info_user['user_id'])
				$this->classes->error->simple_error('no_edit_your');
				
			if(time()-300 > $temp['dateline'])
				$this->classes->error->simple_error('no_edit_time');
		}
		else
			$init_text='[quote="('.$temp['user_nick'].' @ '.gmdate('d F Y H:i',$temp['dateline']).')"]'.stripslashes($temp['text']).'[/quote]';
	}
	else
	{
		$init_text='0';
	}
		
	//---------------------------------
	// Perm control
	//---------------------------------
	$query = $this->classes->db->execQuery($this->classes->db->sql_build('showthread_nav', array($tid, $this->classes->user->info_user['level'])));
	$nav=$this->classes->db->fetch_array($query);
	
	$nav['type'] = '<a href="#" class="nav">'.$this->classes->lang->lang_all['newpost']['main']['title'].'</a>';
	$this->classes->skin->assign('nav', $nav);
	
	//can view, can read | can read, can start, can upload
	if(! ($nav['perm'][3] ) )
			$this->classes->error->login_error('no_perm');
			
	//fetch subscription if it is
	$query2 = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_sub_thread_by_id', array($this->classes->user->info_user['user_id'], $tid) ) );
	
	$newpost['type'] = 'newpost';
	$newpost['forumid'] = 0;
	$newpost['thread_id'] = $tid;
	$newpost['text'] = $init_text;
	$newpost['sub'] = $this->classes->db->num_rows($query2);
	$newpost['title'] = $this->classes->lang->language['title'];
	
	
	if(isset($_GET['edit']))
	{
		$newpost['formaction'] = 'index.php?act=newpost&edit='.intval($_GET['edit']);
		$newpost['edit'] = 1;
	}
	else
	{
		$newpost['formaction'] = 'index.php?act=newpost';
		$newpost['edit'] = 0;
	}
	
	
	$this->classes->skin->assign('newpost', $newpost);
	
	$thread=new Thread($this->classes, $tid);
	
	$thread->fetch_posts_by_tid($tid, 0, 1);
	
	}
else
	{
	require 'inc/class_uploads.php';
		
	if(!strstr($_SERVER['HTTP_REFERER'],$this->classes->_config['board_domain']))
		$this->classes->error->simple_error('no_perm');
	
	$this->classes->var_filtrer->add($_POST);
	
	$topicid = $this->classes->var_filtrer->Integer('topicid');
	$text = $this->classes->var_filtrer->String('replybox');
	$title = $this->classes->var_filtrer->String('title',0);
	$options = $this->classes->var_filtrer->String('options');
	$subscribe = $this->classes->var_filtrer->Integer('subscribe');
	$username = $this->classes->var_filtrer->String('username',0);
	
	//---------------------------------
	// Perm control
	//---------------------------------
	$query = $this->classes->db->execQuery($this->classes->db->sql_build('showthread_nav', array($topicid, $this->classes->user->info_user['level'])));
	$nav=$this->classes->db->fetch_array($query);
	
	//can view, can read | can read, can start, can upload
	if(! ($nav['perm'][3] ) )
			$this->classes->error->login_error('no_perm');
	
	$thread = new Thread($this->classes, $topicid);

	//--------------------------------
	// Check if the thread is moved or closed
	//--------------------------------	
	
	if( $thread->thread['closed'] == 1 || $thread->thread['move_url'] != 0 )
		$this->classes->error->simple_error('closed_thread');
	
	//--------------------------------
	// Anti-flood control
	//--------------------------------
	if($this->classes->user->info_user['user_id'] > 0)
	{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_last_user_post_dateline', $this->classes->user->info_user['user_id'] ));
		if($this->classes->db->num_rows($query) > 0)
		{
			$temp_vett = $this->classes->db->fetch_array($query);
			
			if(time() -30 < $temp_vett['dateline'] )
					$this->classes->error->simple_error('antiflood');
		}
	}
	
	if(isset($_GET['edit']))
	{
		$post_id = intval($_GET['edit']);
		
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_post_by_id', $post_id ));
		$vett=$this->classes->db->fetch_array($query);
		
		
		if(time()-300>$vett['dateline'])
			$this->classes->error->simple_error('no_edit_time');
		
		
		if($vett['user_id'] != $this->classes->user->info_user['user_id'])
			$this->classes->error->simple_error('no_edit_your');
		
		$thread->edit_post($post_id, $text);
	
	}
	else
	{
	if(strlen($text)<5)
		$this->classes->error->simple_error('text_len');
		
	if($this->classes->user->info_user['level'] < 1)
		if(strlen($username)<2)
			$this->classes->error->simple_error('spec_username');
		else
			$this->classes->user->info_user['user_nick'] = $username;

	//--------------------------------
	// Upload file
	//--------------------------------			
	if(strlen($_FILES['upload']['name'])>5)
	{
		//can view, can read | can read, can start, can upload
		if(! ($nav['perm'][4] ) )
			$this->classes->error->login_error('upload_perm');
			
		$up = new File_Upload($this->classes);
		$upid = $up->process();
	}
	else
		$upid = 1;	
		
	$return_post = $thread->new_post($topicid, $title, $text, $this->classes->user->info_user, 1, $this->classes->var_filtrer->Integer('bbcodecheck'));	
	}
	if($this->user->info_user['level'] <= 5)
		$options='none';
	
	switch($options)
	{
		case 'pin': $thread->pin_thread($topicid); break;
		case 'close': $thread->close_thread($topicid); break;
		case 'closepin': $thread->pin_thread($topicid); $thread->close_thread($topicid); break;
	}
	
	if( $subscribe == 1 )
		$thread->thread_subscribe( $topicid );
		
	if($upid != 1)
	{
		$this->classes->db->execQuery($this->classes->db->sql_build('fetch_post_text_pid', array($upid, $return_post) ));
	}	
	//---------------------------------
	// Go at posted post (lol)
	//---------------------------------
	
	$this->classes->error->complete('index.php?act=showthread&tid='.$topicid.'&view=lastposts#post-'.$return_post, $this->classes->lang->language['new_post'].$options);
	}

?>