<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/

class Forum
	{
	/**
    * information of selected forum
    * @access Private
    * @var array()
    */
	var $forum;
	var $classes;
	
	/**
    * Forum Constructor
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return none
    */
	function Forum(& $classes, $fid=0)
		{
		
		$this->classes= & $classes;
		
		if($fid!=0)
		{
			//----------------------------------
			// Load forum informations
			//----------------------------------
        	$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_forum_by_id', $fid));
			$this->forum=$this->classes->db->fetch_array($query);
			if($this->forum['move_url']!=0)
				$this->classes->error->complete($this->forum['move_url'], 'Reindirizzamento in corso...');
			
		}
		
		/*if(!isset($this->forum['id']))
			$revoke->error();*/
			
		}
		
	
	/**
    * Show category
    *
    * @param int $category_id
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return array()
    */
	function show_category($category_id)
		{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_forums_by_catid', array($this->classes->user->info_user['level'], $category_id) ));
	
		
		while($vett=$this->classes->db->fetch_array($query))
		{
			
			if( (!$vett['perm'][0]) && $this->classes->user->info_user['admincp']!=1)
				continue;
				
			$count=1;
				
			$vett['title'] = stripslashes($vett['title']);
			$vett['lastaction'] = gmdate('d F Y H:i',$vett['lastaction']);
			
			if($vett['closed']==1)
				$vett['state']=8;
			else
				if($vett['move_url'] != 0)
					$vett['state']=7;
				else
				{
				//	if($user['lastaction']>($vett['datelinesav']+10000))
				//		$vett['state']=2;
				//	else
						$vett['state']=1;
						
				}
			
			$title = $vett['cat_title'];
			$all_vett[] = $vett;
		}
		
		$this->classes->skin->assign('forums', $all_vett);
		$this->classes->skin->assign('cat_id', $cat_id);
		$this->classes->skin->assign('title', $title);
		
		}

	/**
    * Show a forum by forum_id
    *
    * @param int $id, array() $user
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */			
	function show_forum($id, $start)
	{
		
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_threads_and_posttext_by_id', array($id,$start) ));
		
			while($vett=$this->classes->db->fetch_array($query))
			{
				
				if($vett['sticky']==1)
					$vett['title'] = 'In Rilievo: '.$vett['title'];
				else
					if($vett['pollid'] != 0)
						$vett['title'] = 'Poll: '.$vett['title'];
				
				$vett['datelinesav'] = $vett['dateline']; 
				
				$vett['dateline'] = gmdate('d F Y H:i', $vett['last_update']);
				
				if($this->classes->user->info_user['user_id']<1)
				{
					if($vett['closed']==1)
						$vett['state'] = 8;
					else
						$vett['state'] = 2;
						
				}
				else
				{ 
					if($vett['closed'] == 1)
						$vett['state'] = 8;
					else
						if($vett['moved_id']!=0)
							$vett['state']=7;
						else
						{
							if(!$this->is_visited($vett['thread_id'], $vett['datelinesav']))
								$vett['state'] = 1;
							else
								$vett['state'] = 2;
						
							/*if($vett['poolid']!=0)
								$vett['state']=$vett['state']+4;
							else*/
								if($vett['reply'] >= 100)
								$vett['state']=$vett['state']+2;
						}
				
				} 
				
				if($vett['reply'] > 9)
				{
					$num_link = intval( ($vett['reply']+1) / 10);
					
					if( (($vett['reply']+1) / 10) > $num_link)
						$num_link++;
					
					$linkpage = '';
					
					for($i=0; ($i<3 && $i<$num_link); $i++)
					{
						$linkpage.= '<span class="minipagelink"><a href="index.php?act=showthread&tid='.$vett['thread_id'].'&start='.($i*10).'">'.($i+1).'</a></span>';
					}
					
					if($num_link > 4 )
						$linkpage.= '<span class="minipagelink"><a href="index.php?act=showthread&tid='.$vett['thread_id'].'&start='.(($num_link-1)*10).'">&gt;&gt;'.$num_link.'</a></span>';
					else
						if($num_link == 4)
							$linkpage.= '<span class="minipagelink"><a href="index.php?act=showthread&tid='.$vett['thread_id'].'&start=30">4</a></span>';
				}
				else
					$linkpage = '0';
					
				$vett['text']=substr(strip_tags(html_entity_decode(stripslashes($vett['text']))),0,60);
				$vett['links']= $linkpage;
				 
				
				
				$all_vett[]=$vett;
			}
		
		$this->classes->skin->assign('num_threads', $this->classes->db->num_rows($query));	
		$this->classes->skin->assign('threads', $all_vett);

		//----------------------------------
		// Load into the template
		//----------------------------------

		
	}
		
	/**
    * Show index forums and cats
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */			
	function show_index_forums()
	{

		$prec='';
		
		$count=0;
		$count2=0;
		//----------------------------------
		// SQL Cached vett init
		//----------------------------------
		if($this->classes->user->info_user['level'] == 0)
			$all_vett = $this->classes->cache->GetFromCache('sql_index_forum-0', 0, true);
		else
			$all_vett = false;
			
		if($all_vett)
			$cached = true;
		else
		{
			//----------------------------------
			// Categories and Forums
			//----------------------------------
			$query = $this->classes->db->execQuery($this->classes->db->sql_build('index_forums', $this->classes->user->info_user['level']));
			$all_vett = array();
			$cached = false;
		//}

		while($vett=$this->classes->db->fetch_array($query))
		{
			/*if($cached)
			{
				if($count == $tot)
					break;
				$vett = $all_vett[$count][$count2];
			}*/
			//else
				
			
			
			if( (!$vett['perm'][0]) && $this->classes->user->info_user['admincp']!=1)
				continue;
			
			$vett['lastaction'] = gmdate('d F Y H:i',$vett['lastaction']);
				
			if($count==0 && $count2 == 0)
				$prec=$vett['cat_id'];
			else
			if($prec!=$vett['cat_id'])
			{
				
				if($prec!='')
					$this->classes->skin->content.='</cat>';
				$this->classes->skin->content.='<cat><cat_id>'.$vett['cat_id'].'</cat_id><title>'.$vett['cat_title'].'</title>'.$lang_cat;
				$count++;
				$count2=0;
				$prec=$vett['cat_id'];
			}
			
			
				
			$vett['title']=stripslashes($vett['title']);
			
			
			if($vett['closed']==1)
			$vett['state']=8;
		else
			if($vett['move_url']!=0)
					$vett['state']=7;
				else
					{
					//	if($user['lastaction']>($vett['datelinesav']+10000))
					//		$vett['state']=2;
					//	else
							$vett['state']=1;
						
					}
			
			$all_vett[$count][$count2] = $vett;
			
			$count2++;
			
		}
		}
		
		$this->classes->skin->assign('forums', $all_vett);
		//----------------------------------
		// SQL Cache write
		//----------------------------------
		if(!$cached && $this->classes->user->info_user['level'] == 0)
			$this->classes->cache->WriteToCache('sql_index_forum-0', $all_vett);
		
	}	
	
	/**
    * Show index forums and cats
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */			
	function show_admin_forums()
	{

		$prec='';
		$js = '';
		$all_js = '';
		$count=0;
		$count2=0;
			//----------------------------------
			// Categories and Forums
			//----------------------------------
			$query = $this->classes->db->execQuery($this->classes->db->sql_build('admin_index_forums'));
			$all_vett = array();
			$cached = false;

		while($cached || ($vett=$this->classes->db->fetch_array($query)))
		{
				
			
			
			if( (!$vett['perm'][0]) && $this->classes->user->info_user['admincp']!=1)
				continue;
			
			$vett['lastaction'] = gmdate('d F Y H:i',$vett['lastaction']);
			
			
				
			if($count==0 && $count2 == 0)
			{
				$prec=$vett['cat_id'];
				
				$js.= '
function updateOrder_'.$vett['cat_id'].'()
            {
                var options = {
                                method : \'post\',
                                parameters : Sortable.serialize("list_'.$vett['cat_id'].'"),
								onComplete : function(request) {
								alert("Aggiornamento ordine forums eseguito con successo");
								//new Ajax.Updater(\'stats\', \'index.php\', {asynchronous:true, evalScripts:true});								
                        // turn off update message here
                    }
                              };
 
                new Ajax.Request(\'index.php?act=admin&code=forums&s=01&cid='.$vett['cat_id'].'\', options);
            }
        
   Sortable.create("list_'.$vett['cat_id'].'", {dropOnEmpty:true,containment:["firstlist","secondlist"], onUpdate : updateOrder_'.$vett['cat_id'].' });';
			$all_js.= '"list_'.$vett['cat_id'].'",';
			}
			
		
			if($prec!=$vett['cat_id'])
			{
				
				$count++;
				$count2=0;
				$prec=$vett['cat_id'];
				$js.= '
function updateOrder_'.$vett['cat_id'].'()
            {
                var options = {
                                method : \'post\',
                                parameters : Sortable.serialize("list_'.$vett['cat_id'].'"),
								onComplete : function(request) {
								alert("Aggiornamento ordine forums eseguito con successo");
								//new Ajax.Updater(\'stats\', \'index.php\', {asynchronous:true, evalScripts:true});								
                        // turn off update message here
                    }
                              };
 
                new Ajax.Request(\'index.php?act=admin&code=forums&s=01&cid='.$vett['cat_id'].'\', options);
            }
        
   Sortable.create("list_'.$vett['cat_id'].'", {dropOnEmpty:true,containment:["firstlist","secondlist"], onUpdate : updateOrder_'.$vett['cat_id'].' });

 ';
			$all_js.= '"list_'.$vett['cat_id'].'",';
			}
			
				$js .= 'new Ajax.InPlaceEditor(\'name_'.$vett['forum_id'].'\', \'index.php?act=admin&code=forums&s=02&fid='.$vett['cat_id'].'\');';
				
			
				
			$vett['title']=stripslashes($vett['title']);
			
			
			if($vett['closed']==1)
			$vett['state']=8;
		else
			if($vett['move_url']!=0)
					$vett['state']=7;
				else
					{
						
							$vett['state']=1;
						
					}
			
			$all_vett[$count][$count2] = $vett;
			
			
			$count2++;
			
			
		}
		$all_js[strlen($all_js)-1] = ' ';
		$js = str_replace('containment:["firstlist","secondlist"]', 'containment:['.$all_js.']', $js);
		$this->classes->skin->assign('js', '<script type="text/javascript">'.$js.'</script>');
		$this->classes->skin->assign('forums', $all_vett);
		
		
	}	
	
	/**
	* Update forum order for admincp-ajax
	*
	* @param int $key
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/	
	function update_forum_order($key)
	{
        if (!isset($_POST[$key]) || !is_array($_POST[$key]))
            return;
 
        $ranking = 1;
		
		$category_id = $key[5];
 
        foreach ($_POST[$key] as $cat_id) 
		{
			
			$query = $this->classes->db->execQuery($this->classes->db->sql_build('update_forum_rank', array ($ranking, $category_id, $cat_id) ));
			
			
			$ranking++;
			
		}
		
		$this->classes->cache->RemoveFromCache('sql_index_forum-0');
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_all_groups' ));
				$prec = $this->classes->skin->cache;
		$this->classes->skin->cache = true;
		$this->classes->skin->clear_all_cache();
		$this->classes->skin->cache = $prec;
		
	}


	/**
	* rename a forum
	*
	* @param string $name, int $fid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/	
	function rename_forum($name, $fid)
	{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('forum_rename', array ($name, $fid) ));
		
		$this->classes->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_all_groups' ));
				$prec = $this->classes->skin->cache;
		$this->classes->skin->cache = true;
		$this->classes->skin->clear_all_cache();
		$this->classes->skin->cache = $prec;
	}
	
	/**
	* Syncronize forum lastthread and threads-posts count
	*
	* @param int $fid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/	
	function sync_forum($fid)
	{
	
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('sync_forums_lastthread',$fid));
		$last = $this->classes->db->fetch_array($query);
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('sync_forums_lastthread_update', array($last['lastposter'], $last['lastposterid'], $last['title'], $last['thread_id'], $last['last_update'], $fid)));
		
		$this->sync_forum_threads($fid);
		
		$this->classes->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_all_groups' ));
				$prec = $this->classes->skin->cache;
		$this->classes->skin->cache = true;
		$this->classes->skin->clear_all_cache();
		$this->classes->skin->cache = $prec;
	}

	/**
	* Syncronize forum threads-posts count
	*
	* @param int $fid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/	
	function sync_forum_threads($fid)
	{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('sync_forums_count_all', $fid));
		$forum=$this->classes->db->fetch_array($query);
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('update_forum_count', array($forum['replies'], $forum['threads'], $fid) ));
		
		$this->classes->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_all_groups' ));
				$prec = $this->classes->skin->cache;
		$this->classes->skin->cache = true;
		$this->classes->skin->clear_all_cache();
		$this->classes->skin->cache = $prec;
	}
	
	/**
	* Create a new forum
	*
	* @param array $array
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return bool
	*/	
	function new_forum($array)
	{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('new_forum', array($array['title'], $array['description'], $array['move_url'], $array['cat_id'])));
		$forum_id=$this->classes->db->insert_id();
		$query2= $this->classes->db->execQuery($this->classes->db->sql_build('fetch_all_groups'));
		while($vett=$this->classes->db->fetch_array($query2))
		{
			$this->classes->db->execQuery($this->classes->db->sql_build('insert_forum_perm', array($vett['gid'], $array['perm_'.$vett['gid']], $forum_id)));
		}
		
		$this->classes->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_all_groups' ));
				$prec = $this->classes->skin->cache;
		$this->classes->skin->cache = true;
		$this->classes->skin->clear_all_cache();
		$this->classes->skin->cache = $prec;
		
		return $query;
	}
	
	/**
	* Create a new category
	*
	* @param array $array
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return bool
	*/	
	function new_category($name)
	{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('new_cat', $name ));
		
		
		$this->classes->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_all_groups' ));
				$prec = $this->classes->skin->cache;
		$this->classes->skin->cache = true;
		$this->classes->skin->clear_all_cache();
		$this->classes->skin->cache = $prec;
		
		return $query;
	}
	
	/**
	* Delete a forum
	*
	* @param int $fid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return bool
	*/	
	function delete_forum($fid)
	{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('delete_forum', $fid ));
		$query2= $this->classes->db->execQuery($this->classes->db->sql_build('delete_perms_by_fid', $fid));
		
		$this->classes->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_all_groups' ));
				$prec = $this->classes->skin->cache;
		$this->classes->skin->cache = true;
		$this->classes->skin->clear_all_cache();
		$this->classes->skin->cache = $prec;
		
		return $query;
	}
	
	/**
	* Delete a category
	*
	* @param int $fid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return bool
	*/	
	function delete_cat($cid)
	{
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('delete_cat', $cid ));
		
		$this->classes->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_all_groups' ));
				$prec = $this->classes->skin->cache;
		$this->classes->skin->cache = true;
		$this->classes->skin->clear_all_cache();
		$this->classes->skin->cache = $prec;
		
		return $query;
	}
	
	/**
	* Check if the thread is "new"
	* @param int tid
	* @param int time
	* @author denadai2 <denadai2@gmail.com>
	* since v 1.0
	* @access Public
	* @return none
	*/	
	function is_visited($tid, $time=0)
	{
		
		if($time < $_SESSION['lastaction'] || $this->classes->user->has_visited($tid, '', 0))
			return true;
		
		//$_SESSION['tid_view'][] = $tid;
		return false;
	}	
	
}


?>