<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/

class Language
	{
	
	/**
    * languages dir
    * @access Private
    * @var string
    */
	var $path='languages/';
	
	/**
    * selected language
    * @access Private
    * @var string
    */
	var $lang;
	
	/**
    * array of language strings
    * @access Public
    * @var array
    */
	var $language;
	
	var $lang_all;

	/**
    * Set a language
    *
    * @param string $language
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */	
	function setlanguage($language='italian')
	{
	if($this->language_exists($language))
		{
		$this->lang=$language;
		return true;
		}
	else
		return false;
	}
	
	/**
    * check if a language exists
    *
    * @param string $language
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */
	function language_exists($language)
		{
		return file_exists($this->path.$language.'/');
		}

	/**
    * load the selected array
    *
    * @param string $section
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */		
	function load($section, $add='')
		{
		if(file_exists($this->path.$this->lang.'/main'.$add.'.php'))
			require $this->path.$this->lang.'/main'.$add.'.php';
		else
			return false;
			
		$this->lang_all=$lang;
		$this->language=$lang[$section]['main'];
		return true;
		}
		
	/**
    * return the lang in a xslt format
    *
    * @param string $section
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */		
	function lang2xslt($section)
	{
		/*$temp='';
		
		while (list($chiave, $valore) = each($this->lang_all[$section])) 
   			$temp .= "<$chiave>$valore</$chiave>";
		
	return $temp;*/
	}

	/**
    * Load a specific array from a file
    *
    * @param string $file
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */		
	function load_file($file)
		{
		if(file_exists($this->path.$this->lang.'/'.$file.'.php'))
			require $this->path.$this->lang.'/'.$file.'.php';
		else
			return false;
			
		$this->language=$lang;
		return true;
		}

	/**
    * Transform xml to an array
    *
    * @param string $xml
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return array()
    */	
	function xml2array ($xml)
	{
		$xmlary = array ();
		
		//$xml = preg_replace('/<(\w+)([^>]*)\/>/s','<\1\2></\1>',$xml);
		$ReElements = '/<(\w+)\s*([^\/>]*)\s*(?:\/>|>(.*)<\/\s*\\1\s*>)/s';
		$ReAttributes = '/(\w+)=(?:"|\')([^"\']*)(:?"|\')/';
		
		preg_match_all ($ReElements, $xml, $elements);
		//print_r($elements); exit;
		foreach ($elements[1] as $ie => $xx) 
		{
			
			$xmlary[$ie]["name"] = $elements[1][$ie];
			if ( $attributes = trim($elements[2][$ie])) 
			{
				preg_match_all ($ReAttributes, $attributes, $att);
				foreach ($att[1] as $ia => $xx)
				// all the attributes for current element are added here
				$xmlary[$ie]["attributes"][$att[1][$ia]] = $att[2][$ia];
			} // if $attributes
		
			// get text if it's combined with sub elements
			$cdend = strpos($elements[3][$ie],"<");
			if ($cdend > 0) 
			{
				$xmlary[$ie]["text"] = substr($elements[3][$ie],0,$cdend -1);
			} // if cdend
		
			if (preg_match ($ReElements, $elements[3][$ie]))       
				$xmlary[$ie]["elements"] = $this->xml2array ($elements[3][$ie]);
			else if ($elements[3][$ie])
			{
				$xmlary[$ie]["text"] = $elements[3][$ie];
			}
		}
		return $xmlary;
	}
	
	/**
    * Transform xml in a php file
    *
    * @param string $xml
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return nonr
    */	
	function xml2php($xml)
	{
		$array=$this->xml2array($xml);
		 print_r($array); 
		$array=$array[0]['elements'];
		@mkdir('languages/'.$array[0]['text'],0777);
		
		
		$countfiles=count($array);
		
		for($u=1;$u<$countfiles; $u++)
		{
		$f=fopen('languages/'.$array[0]['text'].'/'.$array[$u]['name'].'.php','w');	
		fwrite($f,'<?php'."\n"."\n");
			$count=count($array[$u]['elements']);
			
			
			
			if($array[$u]['name']=='errors')
			{
			
				$count2=count($array[$u]['elements']);
				fwrite($f,'$lang = array(		'."\n\n");
				for($k=0; $k<$count2;$k++) //main
				{
					if( $k < ( $count2 - 1 ) )
							$temp=',';
						else
							$temp='';
					
						fwrite($f,'				\''.$array[$u]['elements'][$k]['name'].'\'			=>		\''.addslashes($array[$u]['elements'][$k]['text']).'\''.$temp."\n");
	
				}
			}
			else
				for($i=0;$i<$count;$i++) //main
				{
			
					$count2=count($array[$u]['elements'][$i]['elements']); 
					
						for($j=0; $j<$count2;$j++) //forums
						{
							$count3=count($array[$u]['elements'][$i]['elements'][$j]['elements']);
							
							fwrite($f,'$lang[\''.$array[$u]['elements'][$i]['name'].'\'][\''.$array[$u]['elements'][$i]['elements'][$j]['name'].'\'] = array(		'."\n\n");
							for($k=0; $k<$count3;$k++) //main
							{
							
								if( $k < ( $count3 - 1 ) )
										$temp=',';
									else
										$temp='';
								
									fwrite($f,'				\''.$array[$u]['elements'][$i]['elements'][$j]['elements'][$k]['name'].'\'		=>		\''.addslashes($array[$u]['elements'][$i]['elements'][$j]['elements'][$k]['text']).'\''.$temp."\n");
				
							}
								
							fwrite($f,'
											);'."\n\n");
						}
						
					
					
					
				}
			fwrite($f,'?>');
			fclose($f);
		}
	
	
	}

	/**
    * Transform all php files in language directory in xml
    *
    * @param String $lang_name
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return String
    */	
	function php2xml($lang_name)
	{
		$xml='<?xml version="1.0" encoding="iso-8859-1"?>'."\n".'<lang><language>'.$lang_name.'</language>'."\n";
		$dirpath = $this->path.$lang_name;
		$dh = opendir($dirpath);
		   while (false !== ($file = readdir($dh))) {
	
			  if (!is_dir("$dirpath/$file")) 
			  	$xml.=$this->array2xml($file,$lang_name);
	}
		$xml.='</lang>';
		closedir($dh); 
		return $xml;
	}
	
	/**
    * Transform an array in a xml file
    *
    * @param String $filename, int $indent
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return String
    */	
	function array2xml($filename,$lang_name)
	{
	
		if(file_exists($this->path.$lang_name.'/'.$filename))
			require $this->path.$lang_name.'/'.$filename;
		else
			return false;
		$array=$lang;
		
		//names of the keys [forums]
		$name=array_keys($lang);
		$count=count($name);
		
		$filename_xml=explode('.',$filename);
		$xml.='<'.$filename_xml[0].'>';
		
		if($filename=='errors.php')
		{
			for($k=0;$k<$count;$k++)
			{
				$xml.=$this->indent($i+$j+1).'<'.$name[$k].'>'.$lang[$name[$k]].'</'.$name[$k].'>';
			}
			
			$xml.='</'.$filename_xml[0].'>';
			return $xml;
		}
		
		
		for($i=0;$i<$count;$i++)
		{
			$xml.=$this->indent(0).'<'.$name[$i].'>';
			//names of the keys [forums][main]
			$name2=array_keys($lang[$name[$i]]);
			$count2=count($name2);
			
			
			for($j=0;$j<$count2;$j++)
			{
				$xml.=$this->indent($i).'<'.$name2[$j].'>';
				$name3=array_keys($lang[$name[$i]][$name2[$j]]);
				$count3=count($name3);
				
				for($k=0;$k<$count3;$k++)
				{
					$xml.=$this->indent($i+$j+1).'<'.$name3[$k].'>'.$lang[$name[$i]][$name2[$j]][$name3[$k]].'</'.$name3[$k].'>';
				}
				
				$xml.=$this->indent($i).'</'.$name2[$j].'>';
			}
			
			$xml.=$this->indent(0).'</'.$name[$i].'>';
		}
		
		$xml.='</'.$filename_xml[0].'>';
		
		return $xml;
	}

	/**
    * Indent the code
    *
    * @param int $level
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return String
    */
	function indent($level)
	{
		$indent = "";
		for($ix = 1; $ix <= $level; $ix++)
		{
			$indent .= " ";
		}
		return("\n".$indent);
	}
	
	/**
    * Import a language file
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return none
    */
	function import_lang($filelocation)
	{
		$xml=file_get_contents($filelocation);
		$this->xml2php($xml);
		
	}
	
	/**
    * Export a language file
    *
    * @param String $string
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return File
    */
	function export_lang($string)
	{
		$xml=$this->php2xml($string);
		//if(strlen($xml)>7)
		$filelocation='uploads/export_'.time().rand(0,150).'.xml';
		$f=fopen($filelocation,'w');
		fwrite($f,$xml);
		fclose($f);
		header('HTTP/1.1 200 OK');
		header('Date: ' . date("D M j G:i:s T Y"));
		header('Last-Modified: ' . date("D M j G:i:s T Y"));
		header("Content-Type: application/force-download"); // changed to force download
		header("Content-Lenght: " . (string)(filesize($filelocation)));
		header("Content-Transfer-Encoding: Binary"); // added
		header("Content-Disposition: attachment; filename=\"$filelocation\""); // added to remove spaces in filename when saving, it seemed to cause some problems with spaces.
		readfile($filelocation);
		unlink($filelocation);
		exit;
	}
	
}
	