<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/

if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

class Search
	{
	var $classes;
	
	/**
    * Search Constructor
    *
    * @param class $classes
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return none
    */
	function Search(& $classes)
		{
		
		$this->classes= & $classes;
			
		}
		
	/**
    * Do a fast thread search
    *
    * @param String $string
    * @param Integer $start
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return none
    */	
	function fast_thread_search($string, $start, $stop)
	{
	if($start > '0')
		$str = ($start - 1)*$stop;
	else
		$str = 0;	
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('simple_search_topics', array($string, $string, $str, $stop ) ));
		
		
		while($vett = $this->classes->db->fetch_array($query))
		{
			if($vett['sticky']==1)
					$vett['title']='In Rilievo: '.$vett['title']; 
				
				$vett['datelinesav']=$vett['dateline']; 
				
				$vett['dateline']=gmdate('d-m-Y H:i:s',$vett['dateline']);
				
				if($this->classes->user->info_user['user_id']<1)
				{
					if($vett['closed']==1)
						$vett['state']=8;
					else
						$vett['state']=2;
				}
				else
				{
					if($vett['closed']==1)
						$vett['state']=8;
					else
						if($vett['moved_id']!=0)
							$vett['state']=7;
						else
						{
							if($this->classes->user->info_user['lastaction']>($vett['datelinesav']+10000))
								$vett['state']=2;
							else
								$vett['state']=1;
						
							if($vett['poolid']!=0)
								$vett['state']=$vett['state']+4;
							else
								if($vett['reply']>=100)
								$vett['state']=$vett['state']+2;
						}
				
				} 
				 
				
				$vett['text'] = substr(strip_tags(html_entity_decode(stripslashes($vett['text']))),0,60);
			
				if(false == isset($top_score) && isset($vett['score']))
				{
					$top_score = $vett['score'];
				}
	
				if(isset($vett['score']))
				{
				   $vett['score'] = round($vett['score'] / $top_score * 100);
				}
			
				$all_vett[]=$vett;
		}
		
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('simple_search_topics_num', array($string, $string ) ));
		$tot = $this->classes->db->num_rows($query);
		
		$this->classes->skin->assign('num_threads', $this->classes->db->num_rows($query));	
		$this->classes->skin->assign('threads', $all_vett);
		$this->classes->skin->assign('search', 1);
		$this->classes->skin->assign('form', '<form action="'.$this->classes->_config['board_domain'].$this->classes->_config['board_url'].'index.php?act=search" method="post">');
		$this->classes->skin->assign('formpost', '</form>');
		$this->classes->skin->assign('page', generate_pagination_button($this->classes->_config['board_domain'].$this->classes->_config['board_url'].'index.php?act=search', $tot, $stop, $str, "start"));
		$this->classes->skin->assign('hid', "<input type='hidden' value='".$string."' name='search' />");
		
	}
	
	function full_thread_search($string, $nam, $match, $oby, $typ, $dat, $start, $stop, $frm, $search_name, $frum)
	{
		$arr['typ'] = $typ;
		$arr['start'] = $start;
		$arr['mpp'] = $stop;
		$arr['oby'] = $oby;
		$arr['dat'] = $dat;
		$arr['frm'] = $frm;
		
		
		$query = $this->classes->db->execQuery($this->classes->db->sql_build('fetch_search_cache', array(md5($search_name.$search_string.$dat.$start.$stop), addslashes(serialize($arr)),$start) ));
			
		if($this->classes->db->num_rows($query) == 1)
		{
			$temp = $this->classes->db->fetch_array($query);
			$all_vett = unserialize(stripslashes($temp['query_cache']));
		}
		else
		{
			if(strlen($string)<4 && strlen($search_name)>2)
				$query = $this->classes->db->execQuery($this->classes->db->sql_build('name_full_search_topics', array($dat, $nam, $frm, $oby, $typ, $start, $stop ) ));
			else
				$query = $this->classes->db->execQuery($this->classes->db->sql_build('full_search_topics', array($match, $string, $match, $string, $dat, $nam, $frm, $oby, $typ, $str, $stop ) ));
			
			while($vett = $this->classes->db->fetch_array($query))
			{
				if($vett['sticky']==1)
						$vett['title']='In Rilievo: '.$vett['title']; 
					
					$vett['datelinesav']=$vett['dateline']; 
					
					$vett['dateline']=gmdate('d-m-Y H:i:s',$vett['dateline']);
					
					if($this->classes->user->info_user['user_id']<1)
					{
						if($vett['closed']==1)
							$vett['state']=8;
						else
							$vett['state']=2;
					}
					else
					{
						if($vett['closed']==1)
							$vett['state']=8;
						else
							if($vett['moved_id']!=0)
								$vett['state']=7;
							else
							{
								if($this->classes->user->info_user['lastaction']>($vett['datelinesav']+10000))
									$vett['state']=2;
								else
									$vett['state']=1;
							
								if($vett['poolid']!=0)
									$vett['state']=$vett['state']+4;
								else
									if($vett['reply']>=100)
									$vett['state']=$vett['state']+2;
							}
					
					} 
					 
					
					$vett['text'] = substr(strip_tags(html_entity_decode(stripslashes($vett['text']))),0,60);
				
					if(false == isset($top_score) && isset($vett['score']))
					{
						$top_score = $vett['score'];
					}
		
					if(isset($vett['score']))
					{
					   $vett['score'] = round($vett['score'] / $top_score * 100);
					}
				
					$all_vett[]=$vett;
			}
			$this->classes->db->execQuery($this->classes->db->sql_build('insert_search_cache', array(md5($search_name.$search_string.$dat.$start.$stop),time(),addslashes(serialize($arr)), $this->classes->user->info_user['user_id'], $_SERVER['REMOTE_ADDR'], addslashes(serialize($all_vett)), $start) ));
			}
		
		if(strlen($string)<4 && strlen($search_name)>2)
			$query = $this->classes->db->execQuery($this->classes->db->sql_build('num_name_full_search_topics', array($dat, $nam, $frm, $oby, $typ ) ));
		else
			$query = $this->classes->db->execQuery($this->classes->db->sql_build('full_search_topics_num', array($match, $string, $match, $string, $dat, $nam, $frm, $oby, $typ ) ));
		
		$tot = $this->classes->db->num_rows($query);
		
		
		
		$this->classes->skin->assign('num_threads', $tot);	
		$this->classes->skin->assign('threads', $all_vett);
		$this->classes->skin->assign('search', 1);
		$this->classes->skin->assign('page', generate_pagination($this->classes->_config['board_domain'].$this->classes->_config['board_url'].'index.php?act=search&amp;search_name='.$search_name.'&amp;typ='.$typ.'&amp;oby='.$oby.'&amp;mpp='.$stop.'&amp;dat='.$dat.'&amp;frum='.$frum.'&amp;start=', $tot, $stop, $start));
	}
	
	
	
}


?>