/**
 * $RCSfile: editor_plugin_src.js,v $
 * $Revision: 1.23 $
 * $Date: 2006/02/10 16:29:38 $
 *
 * @author Moxiequote
 * @copyright Copyright  2004-2006, Moxiequote Systems AB, All rights reserved.
 */

/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('quote', 'en,tr,sv,zh_cn,cs,fa,fr_ca,fr,de,pl,pt_br,nl,da,he,nb,hu,ru,ru_KOI8-R,ru_UTF-8,nn,es,cy,is,zh_tw,zh_tw_utf8,sk');

// Plucin static class
var TinyMCE_quotePlugin = {
	getInfo : function() {
		return {
			longname : 'quote',
			author : 'Moxiequote Systems',
			authorurl : 'http://tinymce.moxiequote.com',
			infourl : 'http://tinymce.moxiequote.com/tinymce/docs/plugin_emotions.html',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},

	/**
	 * Returns the HTML contents of the emotions control.
	 */
	getControlHTML : function(cn) {
		switch (cn) {
			case "quote":
				return tinyMCE.getButtonHTML(cn, 'lang_quote_desc', '{$pluginurl}/images/quote.gif', 'mcequote');
		}

		return "";
	},

	/**
	 * Executes the mceEmotion command.
	 */
	execCommand : function(editor_id, element, command, user_interface, value) {
		// Handle commands
		switch (command) {
			case "mcequote":
				var html = '<p>[quote]Insert here your quote[/quote]</p>';
				tinyMCE.execCommand('mceInsertContent', false, html);

				return true;
		}

		// Pass to next handler in chain
		return false;
	}
};

// Register plugin
tinyMCE.addPlugin('quote', TinyMCE_quotePlugin);
