<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
define('IN_REVOKE', 1);

class RevokeBB_install
{

	var $_path;
	var $skin;
	var $lang;
	var $error;

	function RevokeBB_install()
	{
		session_start();
		$this->_path='';
		
		if(!is_writable('./skins/compile/')) {
			echo 'Set chmod 777 to the dir skins/compile'; exit; }
			
		if(!isset($_GET['lang']) && !isset($_SESSION['language']))
			$_SESSION['language'] = 'english';
		else
			if(!isset($_SESSION['language']))
			{
				if(isset($_GET['lang']))
					$_SESSION['language'] =$_GET['lang'];
			}
	
		
		define ( 'PHP_EXT',     '.php' );
		define ( 'SYSTEM_PATH', $this->_path );
		
		//---------------------------------
		// Fetch the essential core libraries:
		//---------------------------------
		require SYSTEM_PATH . 'inc/t_lite/class.template'		. PHP_EXT;
		require SYSTEM_PATH . 'inc/class_skin'					. PHP_EXT;
		require SYSTEM_PATH . 'inc/class_language'				. PHP_EXT;
		require SYSTEM_PATH . 'inc/class_status'				. PHP_EXT;
		require SYSTEM_PATH . 'inc/functions'					. PHP_EXT;
		
		
		//---------------------------------
		// Skin initialisation
		//---------------------------------
		$config=array( 'default_skin'	=>	'revoke_install'
					);
		$this->skin = new Skin($config);	
		$this->skin->template_dir = 'skins/revoke_install/';
		
		//---------------------------------
		// Language initialisation
		//---------------------------------
		$this->lang = new Language();
		$this->lang->setlanguage('revoke_install');	
		$this->lang->load('install', '_'.$_SESSION['language']);
		
		if(!isset($_GET['step']))
			$step = 1;
		else
			$step = $_GET['step'];
			
		$this->skin->assign('lang_menu', menu_create('lang', $this->dirlist('languages'), 0, 1));
		
		switch($step)
		{
			case 1:{
					$this->Step_1();
					}break;
			case 2:{
					$this->skin->assign('board_domain', 'http://'.$_SERVER['HTTP_HOST']);
					$this->skin->assign('board_url', str_replace('install.php','',$_SERVER['PHP_SELF']));
					}break;
			case 3:{
					$this->Install();
					
					}break;
		}
		//<body>'.$this->lang->lang2xslt('main').'</body>
		
		$this->skin->assign('lang', $this->lang->lang_all);
		$this->skin->assign('step', 'step_'.$step.'.tpl');
		$this->skin->display('main.tpl');
	
	}
		
	function Step_1()
	{
		$can_step_2 = 1;
	
		
		
		
		$check=array();
		$check_name=array();
		$check[] = is_writable('config.php');
		$check[] = is_writable('./');
		$check[] = is_writable('cache/');
		$check[] = is_writable('skins/compile/');
		$check[] = is_writable('uploads/');
		$check[] = is_writable('uploads/avatars/');
		$check_name[] = 'Writable config.php (make it writable with chmod 777)';
		$check_name[] = 'Writable / (make it writable with chmod 777)';
		$check_name[] = 'Writable cache/ (make it writable with chmod 777)';
		$check_name[] = 'Writable skins/compile/ (make it writable with chmod 777)';
		$check_name[] = 'Writable uploads/ (make it writable with chmod 777)';
		$check_name[] = 'Writable uploads/avatars/ (make it writable with chmod 777)';
		$num=count($check);
		
		$checks_all = array();
		
		for($i=0; $i<$num; $i++)
		{
			if(!$check[$i])
				$can_step_2 = 0;
			$checks_all[] = array('val' => intval( $check[$i] ), 'name' => $check_name[$i]);
		}
		
		$this->skin->assign('can_step', $can_step_2);
		$this->skin->assign('checks_file', $checks_all);
		
	
	}
	
	
	function Install()
	{
		$CONFIG = array(
						'host'		=>	$_POST['db_host'],
						'username'	=>	$_POST['db_username'],
						'password'	=>	$_POST['db_pass'],
						'dbname'	=>	$_POST['db_name'],
						'prefix'	=>	$_POST['db_prefix'],
						'db_type'	=>	$_POST['db_type']
		);
		
		$configphp = '<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/


$CONFIG[\'host\']=\''.$CONFIG['host'].'\'; //database host

$CONFIG[\'username\']=\''.$CONFIG['username'].'\'; //database username

$CONFIG[\'password\']=\''.$CONFIG['password'].'\'; //database password

$CONFIG[\'dbname\']=\''.$CONFIG['dbname'].'\'; //database name

$CONFIG[\'dbtype\']=\''.$CONFIG['db_type'].'\'; //database type (avariable mysql and mysqli

$CONFIG[\'lang\']=\'italian\'; //language

$CONFIG[\'prefix\']=\''.$CONFIG['prefix'].'\';

?>';
		
		$f = fopen('config.php','w');
		
		fwrite($f, $configphp);
		
		fclose($f);
		
		
		require SYSTEM_PATH . 'inc/db/class_'.$CONFIG['db_type']	. PHP_EXT;
		
		$db=new database($CONFIG);
		$db->connect();


		$filename = 'install/revokebb.sql';

		$filesize       = filesize($filename);

		if (!$fp = fopen($filename,'rb')) 
		{
			echo "Unable to open file $filename";
		}
		

		$buffer = '';
		$inside_quote = 0;
		$quote_inside = '';
		$started_query = 0;

		$data_buffer = '';

		$last_char = "\n";

		while ((!feof($fp) || strlen($buffer))) 
		{
			do 
			{
				// Deals with the length of the buffer
				if (!strlen($buffer)) 
				{
					$buffer .= fread ($fp,1024);
				}

				// Fiddle around with the buffers
				$current_char = $buffer[0];
				$buffer = substr($buffer, 1);


				if ($started_query)
				{
					$data_buffer .= $current_char;
				} 
				elseif (preg_match("/[A-Za-z]/i",$current_char) && $last_char == "\n") 
				{
					$started_query = 1;
					$data_buffer = $current_char;
				} 
				else 
				{
					$last_char = $current_char;
				}
			} while (!$started_query && (!feof($fp) || strlen($buffer)));


			if ($inside_quote && $current_char == $quote_inside && $last_char != '\\') 
			{
				// We were inside a quote but now we aren't so reset the flag and carry on
				$inside_quote = 0;
			} 
			elseif ($current_char == '\\' && $last_char == '\\')
			{
				$current_char = '';	
			} 
			elseif (!$inside_quote && ($current_char == '"' || $current_char == '`' || $current_char == '\''))
			{
				// We have just entered a new quote
				$inside_quote = 1;
				$quote_inside = $current_char;
			} 
			elseif (!$inside_quote && $current_char == ';') 
			{
				
				$data_buffer = str_replace("%default_admin_name%", $_POST['username'], $data_buffer);
				$data_buffer = str_replace("%default_md5_password%", md5($_POST['password'].'revoke4gurus'), $data_buffer);					
				$data_buffer = str_replace("%default_admin_email%", $_POST['email'], $data_buffer);					
				$data_buffer = str_replace("%action%", time(), $data_buffer);
				$data_buffer = str_replace("%board_name%", $_POST['board_name'], $data_buffer);
				//$data_buffer = str_replace("%cookie%", "phpbb_$board_access_name", $data_buffer);
				$data_buffer = str_replace("%board_url%", $_POST['board_url'], $data_buffer);
				$data_buffer = str_replace("%board_domain%", $_POST['board_domain'], $data_buffer);										
				//$data_buffer = str_replace("images/avatars", "$avatar_folder", $data_buffer);
				$data_buffer = str_replace("revokebb_", $CONFIG['prefix'], $data_buffer);
				

				$db->execQuery($data_buffer);


				$data_buffer = '';
				$last_char = "\n";
				$started_query = 0;
			}

			$last_char = $current_char;
		}


		$new_position = ftell($fp) - strlen($buffer) - strlen($data_buffer);

		fclose($fp);
		$f=fopen('install.lock', 'w');
		fclose($f);
		
		$this->error = new Status($this->lang, $this->skin, $this->_config);
		$this->error->complete($_POST['board_domain'].$_POST['board_url'], $this->lang->language['finish']);
	}
	
function dirlist($dir)
{
	//chdir( '..' );
	$rep=opendir('./languages');
	while (false != ($file = readdir($rep)))
	{
		if (is_dir('./languages/'.$file) && $file!='revoke_install' && $file[0]!='.')
			$listarray[] = $file;
	} 
	return($listarray);
}
 } 

if(file_exists('install.lock'))
{
	echo 'Board gia installata'; exit;
}

$r=new RevokeBB_install();


?>